nrelease: Simplify by not handling multiple kernel configs
[dragonfly.git] / UPDATING
1 # Updating Information for DragonFly users.
2 #
3 #
4 # This file should warn you of any pitfalls which you might need to work around
5 # when trying to update your DragonFly system.  The information below is
6 # in reverse-time order, with the latest information at the top.
7 #
8 # If you discover any problem, please contact the bugs@lists.dragonflybsd.org
9 # mailing list with the details.
10
11 +-----------------------------------------------------------------------+
12 +         UPGRADING DRAGONFLY FROM 5.6 TO LATER VERSIONS                +
13 +-----------------------------------------------------------------------+
14
15 LIBRADIUS AND LIBTACPLUS REMOVED
16 --------------------------------
17
18 Both libraries have been moved from base to DPorts net/ category.
19
20 PAM_SSH MODULE REMOVED
21 ----------------------
22
23 The pam_ssh(8) have been removed from base to DPorts security/pam_ssh.
24
25 UTMP LEGACY API REMOVED
26 -----------------------
27
28 The legacy "utmp" API (getutent() and friends, utmp.h, etc.) has been
29 removed, and we are now using the POSIX "utmpx" API (getutxent(),
30 utmpx.h, etc.) only. The most visible change for users is that the
31 /var/log/wtmp file will no longer be written to, just /var/log/wtmpx.
32 The wtmpcvt(1) utility is provided to convert old wtmp format files to
33 wtmpx.
34
35 To not break old applications, the utmp symbols are still provided by
36 libc as dummy functions that do nothing and always succeed.
37
38 TIMED AND TIMEDC REMOVED
39 ------------------------
40
41 timed(8) and timedc(8) have been removed because they are beyond
42 obsolete for setting the time.
43
44 LIBOPIE, LIBMD REMOVED
45 ----------------------
46
47 Removal of OPIE requires /etc/pam.d/ configs to be updated.
48
49 +-----------------------------------------------------------------------+
50 +         UPGRADING DRAGONFLY FROM 5.4 TO LATER VERSIONS                +
51 +-----------------------------------------------------------------------+
52
53 GCC50 REMOVED
54 -------------
55
56 The GCC50 compiler has been retired.  It has been replaced by a GCC80.
57 The default alternative compiler has stayed the same - GCC47.
58
59
60 PUFFS, PUTTER AND LIBREFUSE REMOVED
61 -----------------------------------
62
63 The puffs(4)/putter(4) subsystem has been removed, along with librefuse,
64 libpuffs, and the mount_psshfs(8) utility. All of these have never been
65 working correctly.
66
67 FFS_ROOT OPTION REMOVED
68 -----------------------
69
70 The FFS_ROOT kernel configuration option has been finally removed, after
71 having been a no-op since 4.9. That means users using a custom kernel
72 configuration file that still contains it need to remove the option from
73 that file.
74
75 +-----------------------------------------------------------------------+
76 +         UPGRADING DRAGONFLY FROM 5.2 TO LATER VERSIONS                +
77 +-----------------------------------------------------------------------+
78
79 DIGI, RP AND SI DRIVERS REMOVED
80 -------------------------------
81
82 The digi(4), rp(4) and si(4) serial drivers have been removed. None of
83 them were in our default kernel configuration file. The sicontrol(8)
84 utility was removed, too.
85
86 MKINITRD COMMAND REMOVED
87 ------------------------
88
89 The mkinitrd(8) command is removed and its functionality is replaced by
90 the new "initrd" make target.  After rebooting into the new world and
91 verifying everything works, execute "make initrd" to upgrade the rescue
92 tools and initrd image.
93
94 IPSEC, IPSEC_ESP AND IPSEC_DEBUG REMOVED FROM VKERNEL64 CONFIG
95 --------------------------------------------------------------
96
97 IPsec has been removed from the system. Of our standard kernel
98 configurations, only the virtual kernel one had it. People running
99 vkernels with configuration files derived from our VKERNEL64 will
100 have to remove these options manually.
101
102 +-----------------------------------------------------------------------+
103 +         UPGRADING DRAGONFLY FROM 5.0 TO LATER VERSIONS                +
104 +-----------------------------------------------------------------------+
105
106 VIRTIO_PCI REMOVED FROM KERNEL CONFIG
107 -------------------------------------
108
109 The "device virtio_pci" line in X86_64_GENERIC has been removed. People
110 with configuration files derived from it have to remove it manually.
111
112 VARIOUS 'R' COMMANDS AND DAEMONS REMOVED
113 ----------------------------------------
114
115 rcp(1), rlogin(1), rlogind(8), rsh(1) and rshd(8) have been removed.
116 For those that still need them, there is the net/bsdrcmds port.
117
118 VARIOUS FORMER OPTIONS REMOVED
119 ------------------------------
120
121 Various former kernel configuration options which had been no-ops for
122 some time were completely removed: SYSVMSG, SYSVSEM, SYSVSHM, P1003_1B,
123 _KPOSIX_VERSION and DSCHED_FQ. Users that have any of these still in
124 their kernel configuration files have to remove them.
125
126 BOOTSTRAPPING LIMITED FROM PRE 4.4
127 ----------------------------------
128
129 Upgrading to 5.1 and later versions now require at least 4.4 in
130 preparations for upcoming base compilers updates.
131
132 IF_PPP, PPPD, IF_FAITH, AND FAITHD REMOVED
133 ------------------------------------------
134
135 if_ppp has been replaced by "user ppp", i.e. ppp(8) and tun(4). It had
136 already been removed from our default kernel configuration before 5.0,
137 so only people with custom configurations based on earlier X86_64_GENERIC
138 will have to remove it manually.
139
140 The faith(4) interface has been completely removed after it had also
141 been removed from our default kernel configuration. 
142
143 +-----------------------------------------------------------------------+
144 +         UPGRADING DRAGONFLY FROM 4.8 TO LATER VERSIONS                +
145 +-----------------------------------------------------------------------+
146
147 FFS_ROOT OPTION DISABLED
148 ------------------------
149
150 The FFS_ROOT option has been made a no-op and will be completely removed
151 at some point in the future. Users with a custom kernel configuration
152 can remove this option from it now.
153
154 +-----------------------------------------------------------------------+
155 +         UPGRADING DRAGONFLY FROM 4.6 TO LATER VERSIONS                +
156 +-----------------------------------------------------------------------+
157
158 DSA OPENSSH KEYS DEPRECATED
159 ---------------------------
160
161 Note that DSA OpenSSH keys were deprecated in the 4.6 to 4.8 release. 
162 If you are upgrading from a release older than 4.8 and use DSA OpenSSH 
163 keys, please update your private/public key pair or risk locking 
164 yourself out.
165
166 AHC, AHD, AIC, NCV, NSP AND STG DRIVERS REMOVED
167 -----------------------------------------------
168
169 They were all in our X86_64_GENERIC kernel configuration file, along with
170 the AHC_REG_PRETTY_PRINT and AHD_REG_PRETTY_PRINT options, so any custom
171 configuration files derived from it need adjustment.
172
173 PORTAL FILE SYSTEM REMOVED
174 --------------------------
175
176 It has been broken for a long time now.
177
178 BINUTILS 2.27 REPLACES 2.24, PRIMARY
179 ------------------------------------
180
181 The oldest of the two versions of Binutils, version 2.24, was removed
182 and replaced with Binutils 2.27.  It becomes the primary version version
183 of binutils and version 2.25 becomes the alternate.
184
185 The accepted values of BINUTILSVER are now "binutils227" (default) and
186 "binutils225".  The building of Binutils 2.25 can be prevented by setting
187 NO_ALTBINUTILS=yes in make.conf.
188
189 COMPAT_43 KERNEL OPTION REMOVED
190 -------------------------------
191
192 It was commented out in our default configs for several years now, but
193 might still be present in custom configs created before Nov. 2011.
194
195 OPENSSL REMOVED
196 ---------------
197
198 OpenSSL has been removed from base and replaced with a private version of
199 LibreSSL.  The previously installed OpenSSL libraries, headers, and man
200 pages will remain on the system unless the "make upgrade" command is
201 specifically instructed to remove them.  To do this, define
202 REMOVE_OPENSSL_FILES for the upgrade command, e.g.
203 "make upgrade REMOVE_OPENSSL_FILES=yes"
204
205 28-Oct-2016: openssl has been replaced by ressl.  It is recommended that any
206 stale OpenSSL files be removed to avoid configuration scripts from using
207 the stale and potentially vulnerable version, but all binaries that are
208 dynamically linked to the OpenSSL libraries should be rebuilt first to
209 avoid breakage.
210
211 OPENSSH HPN REMOVED
212 -------------------
213
214 It has become too cumbersome to maintain HPN patches in OpenSSH in base.
215 To use OpenSSH in base remove HPN config, if you have added it.
216 Check files below for HPN config, see a few lines below.
217   /etc/ssh/ssh_config, /etc/ssh/sshd_config, ~/.ssh/config
218 sshd(8) will fail to start if HPN config is used.
219
220 NOTE: HPN config in sshd_config will prohibit remote access to host using ssh.
221
222 HPN config:
223 HPNDisabled
224 HPNBufferSize
225 TcpRcvBuf
226 TcpRcvBufPoll
227 NoneEnabled
228 NoneSwitch
229 cipher MTR-AES-CTR
230 cipher NONE
231
232 OpenSSH HPN is a patch set to OpenSSH providing higher performance under some
233 circumstances, especially for networking.
234 If HPN functionality is needed, install security/openssh from dports.
235
236 CS, EX AND VX DRIVERS REMOVED
237 -----------------------------
238
239 The cs(4), ex(4) and vx(4) drivers have been removed. They were very
240 old and its doubtful they ever worked properly in x86_64 but they were
241 in X86_64_GENERIC, so custom configurations derived from it have to be
242 adjusted.
243
244 +-----------------------------------------------------------------------+
245 +         UPGRADING DRAGONFLY FROM 4.4 TO LATER VERSIONS                +
246 +-----------------------------------------------------------------------+
247
248 AMD REMOVED
249 -----------
250
251 The am-utils automounter suite has been removed. It stopped working
252 at some point and was never fixed. autofs(5) and the associated
253 userland has been brought in from FreeBSD and replaces it.
254
255 AN DRIVER REMOVED
256 -----------------
257
258 The an(4) driver has been removed. It was in the X86_64_GENERIC kernel
259 config file, so any configurations derived from it have to be adjusted.
260
261 /DEV/DRI GROUP CHANGED
262 ----------------------
263
264 The default group assigned to /dev/dri entries has been changed
265 from 'wheel' to 'video' with the id of '44'. If you want to have
266 access to the dri devices please add yourself to the video group
267 with:
268
269 # pw groupmod video -m $USER
270
271 +-----------------------------------------------------------------------+
272 +         UPGRADING DRAGONFLY FROM 4.2 TO LATER VERSIONS                +
273 +-----------------------------------------------------------------------+
274
275 DSCHED REMOVED
276 --------------
277
278 dsched(4) has been removed and one of its kernel options, DSCHED_FQ, was
279 in our default kernel config file. So the DSCHED_FQ option has been turned
280 into a no-op for now and can be removed from custom configurations.
281
282 EST DRIVER REMOVED, COMPILE_ET AND LIBCOM_ERR TOO
283 -------------------------------------------------
284
285 The est(4) driver has been removed. All CPUs it supported (except one)
286 were 32 bits only. Those who are still using the Core 2 Duo T7500 should
287 report back if there are any issues with this CPU and our regular ACPI
288 P-state support.
289
290 Also, compile_et(1) and com_err(3) have been removed as well. They
291 should have been removed along with kerberos support, back in 2009.
292
293 SEVERAL LOCALES RENAMED
294 -----------------------
295
296 Several locales were using obsolete and misleading names, and thus have
297 been adjusted to current standards. Any users of the following locales
298 need to select alternates:
299
300 DFLY 4.2 locale            DFLY 4.4 alterative locale
301 ---------------            ------------------------------------
302 mn_MN.UTF-8                mn_Cyrl_MN.UTF-8
303 no_NO.UTF-8                nb_NO.UTF-8      or nn_NO.UTF-8
304 no_NO.ISO8859-1            nb_NO.ISO8869-1  or nn_NO.ISO8859-1
305 no_NO.ISO8859-15           nb_NO.ISO8859-15 or nn_NO.ISO8859-15
306 sr_YU.UTF-8                sr_Cyrl_RS.UTF-8 or sr_Latn_RS.UTF-8
307 sr_YU.ISO8859-5            sr_Cyrl_RS.ISO8859-5
308 sr_YU.ISO8859-2            sr_Latn_RS.ISO8859-2
309 zh_CN.GBK                  zh_Hans_CN.GBK
310 zh_CN.UTF-8                zh_Hans_CN.UTF-8
311 zh_CN.eucCN                zh_Hans_CN.eucCN
312 zh_CN.GB2312               zh_Hans_CH.GB2312
313 zh_CN.GB18030              zh_Hans_CH.GB18030
314 zh_HK.Big5HKSCS            zh_Hant_HK.Big5HKSCS
315 zh_HK.UTF_8                zh_Hant_HK.UTF-8
316 zh_TW.Big5                 zh_Hant_TW.Big5
317 zh_TW.UTF-8                zh_Hant_TW.UTF-8
318
319 +-----------------------------------------------------------------------+
320 +         UPGRADING DRAGONFLY FROM 4.0 TO LATER VERSIONS                +
321 +-----------------------------------------------------------------------+
322
323 BINUTILS 2.25 REPLACES 2.22, PRIMARY
324 ------------------------------------
325
326 The oldest of the two versions of Binutils, version 2.22, was removed
327 and replaced with Binutils 2.25.  It becomes the primary version version
328 of binutils and version 2.24 becomes the alternate.  There are 8 current
329 CVE written against 2.24, so for security reasons version 2.25 should
330 always be used.
331
332 The accepted values of BINUTILSVER are now "binutils225" (default) and
333 "binutils224".  The building of Binutils 2.24 can be prevented by setting
334 NO_ALTBINUTILS=yes in make.conf.
335
336 LOADER OPTIONS CHANGED
337 ----------------------
338
339 Right after the development branch started, the Fred art accompanying the
340 loader menu was improved.  The line between Fred and the menu was removed
341 by default (but can optionally be returned) and the placement shifted as
342 a result.  The drawing was improved, and the colored version was improved,
343 changing the eyes and wing color from white to red.  A new color version
344 of Fred was added, one with a blue scheme.
345
346 The loader menu defaults have changed since release 4.0:  The vertical
347 line was removed, the loader is displayed in color by default*, and the
348 blue scheme is used.
349
350 The loader.conf changes are:
351 loader_color:   option has been removed
352 loader_plain:   option has been added, it changed menu to monochrome
353 fred_is_red:    changes color scheme from blue to red
354 fred_is_blue:   option existed only on 4.1, it has been removed
355 fred_separated: Adds line between Fred and menu (as seen previously)
356
357 * If loader.conf defines "console" as "comconsole" or "console" is defined
358   in the environment as "comconsole" then color will not be displayed,
359   even if loader_plain value is "NO".
360
361 SENDMAIL REMOVED FROM BASE
362 --------------------------
363
364 The only Mail Transfer Agent provided now is DragonFly Mail Agent (dma).
365 If the system being upgraded is still configured to use the sendmail
366 binaries from base, the "make upgrade" command will fail.
367
368 The administrator must change /etc/mail/mailer.conf to switch the
369 mailwrapper to dma or a DPorts-based MTA prior to running the upgrade
370 command that permanently removes sendmail executables and could
371 potentially break a running mail server.
372
373 Refer: http://www.dragonflybsd.com/docs/docs/newhandbook/mta/ for
374 detailed instructions on how to configure the MTA selection.
375
376 _KPOSIX_VERSION and P1003_1B OPTIONS REMOVED
377 --------------------------------------------
378
379 The _KPOSIX_VERSION and P1003_1B kernel options have been changed to
380 no-ops. They can be removed from custom kernel configurations.
381
382 SOUND SYSTEM UPDATED FROM FreeBSD 11-CURRENT
383 --------------------------------------------
384
385 Many more sound devices may be detected.
386
387 If the default device choosen isn't to your liking, setting the sysctl
388 hw.snd.default_unit to a different number will change it.
389
390 SCTP SUPPORT DROPPED
391 --------------------
392
393 Support for the SCTP protocol has been removed.
394
395 OLD USB DRIVERS REMOVED
396 -----------------------
397
398 The old USB stack, along with the kernel config option "device oldusb"
399 and the make.conf variable "WANT_OLDUSB" have been removed. This means
400 that for custom kernel configuration files which were derived from a
401 GENERIC or X86_64_GENERIC file prior to making the usb4bsd stack default,
402 various (old USB stack specific) devices will now complain about being
403 unknown:
404
405   * oldusb      (obviously)
406   * natausb     (not yet ported to usb4bsd)
407   * rue         (not yet ported to usb4bsd)
408   * ugen        (no longer needed in usb4bsd)
409   * urio        (not yet ported to usb4bsd)
410   * uscanner    (no longer needed in usb4bsd)
411
412 They should be removed or commented out in such custom kernel configs.
413
414 GCC 5
415 -----
416
417 The GCC 4.4 compiler has been retired.  It has been replaced by a GCC 5.1.
418 The following make.conf variables no longer work: NO_GCC44, NO_OBJC, and
419 NO_CXX.  The latter was never documented and the latest versions of GCC are
420 partially written in C++ so a C++ compiler is no longer optional.  In
421 practical terms it has not been optional for many years as other base
422 components are also written in C++.  The resource savings by avoiding
423 building Objective-C compiler is so small, the complexity added by NO_OBJC
424 internally was deemed a bad tradeoff so that is the reason for its removal.
425 Also note that no "info" pages are installed with GCC 5.  After this entry
426 was originally written, all info pages were removed from DragonFly.
427
428 GCC 5.1 has been designated as the primary compiler.  As such, there is a
429 new make.conf variable, NO_ALTCOMPILER.  It will block the rebuilding of
430 the designated secondary compiler, GCC 4.7.  However, while DPorts
431 primarily uses GCC 5 to build ports now, it still uses GCC 4.7 as well, so
432 if building ports from source is desired, don't block building of the
433 secondary compiler.
434
435 +-----------------------------------------------------------------------+
436 +         UPGRADING DRAGONFLY FROM 3.8 TO LATER VERSIONS                +
437 +-----------------------------------------------------------------------+
438
439 SMP AND DEVICE_POLLING OPTIONS MADE UNKNOWN
440 -------------------------------------------
441
442 DEVICE_POLLING was replaced by IFPOLL_ENABLE and the former SMP code is
443 the default now (even on single-core systems), both for, like, 21 months.
444 We kept the options around as no-ops as a convenience, to allow people
445 using the same config for the then current release and the then current
446 master. That period is now over, so any configs still having those
447 options have to be adjusted.
448
449 SYSVIPC SYSCALLS MADE NON-OPTIONAL
450 ----------------------------------
451
452 The code related to the SYSVMSG, SYSVSEM and SYSVSHM kernel options is
453 now compiled in by default. The options are no-ops for now.
454
455 DEFAULT DRIVER CHANGED FOR LSI "THUNDERBOLT" SERIES RAID CONTROLLERS
456 --------------------------------------------------------------------
457
458 The default driver for those controllers is now mrsas(4) due to reports
459 of file system corruption using the mfi(4) driver. The whole issue (and
460 how to deal with potential problems when switching) was explained here:
461
462 http://lists.dragonflybsd.org/pipermail/users/2014-July/128703.html
463
464 A tunable is provided for letting those controllers still attach via
465 the mfi(4) driver, hw.mrsas.mfi_enable (see mrsas(4) manual page).
466
467 OLDER NETWORK DRIVERS MOVED TO I386 ONLY
468 ----------------------------------------
469
470 The following drivers have been made i386 only: ed(4), sr(4), ng_sync_ar
471 and ng_sync_sr. ed(4) used to be in X86_64_GENERIC, so it has to be
472 removed in kernel configs derived from X86_64_GENERIC.
473
474 +-----------------------------------------------------------------------+
475 +         UPGRADING DRAGONFLY FROM 3.6 TO LATER VERSIONS                +
476 +-----------------------------------------------------------------------+
477
478 UPDATE FROM MOST RECENT 3.6
479 ---------------------------
480
481 Versions of 3.6 built before June 25th have a bug where installworld might 
482 crash during installation of the new initrd.  Upgrade to the latest version
483 of 3.6 before updating to 3.8 or later.
484
485 ATM, IPX, NCP AND NWFS SUPPORT DROPPED
486 --------------------------------------
487
488 Support for the IPX and NCP network protocols and for mouting NetWare
489 file systems has been dropped. Dito for ATM protocol support.
490
491 INITRD IMAGES NOW INSTALLED BY DEFAULT
492 --------------------------------------
493
494 An initial ramdisk image is now installed in /boot/kernel/initrd.img.gz
495
496 Older images installed under the file name of initrd.img will be removed
497 automatically by the make upgrade process.
498
499 USB4BSD IS NOW THE DEFAULT USB STACK
500 ------------------------------------
501
502 To get back to the old stack, put "WANT_OLDUSB=yes" in /etc/make.conf and
503 replace "device usb" with "device oldusb" in the kernel configuration.
504
505 MORE ISA SUPPORT DROPPED
506 ------------------------
507
508 ISA support has been dropped from the following drivers: adv(4), an(4),
509 ar(4), cs(4), digi(4), ed(4), ep(4), ex(4), fe(4), lnc(4), sbni(4),
510 si(4), sn(4), and stg(4).
511
512 +-----------------------------------------------------------------------+
513 +         UPGRADING DRAGONFLY FROM 3.4 TO LATER VERSIONS                +
514 +-----------------------------------------------------------------------+
515
516 ABI CHANGE
517 ----------
518
519 Installed third-party software (dports) will have to be rebuilt after upgrade,
520 or reinstalled from binary packages.
521
522 UPDATING FROM 3.4 TO 3.6
523 ------------------------
524
525 This only applies for this specific upgrade due to locale changes; it is 
526 not needed for upgrades after 3.6.  Please update in this order:
527
528 make buildworld
529 make buildkernel
530 make installworld
531 make installkernel
532 *reboot*
533 make upgrade
534
535 See this mailing list post for details:
536 http://lists.dragonflybsd.org/pipermail/users/2013-September/090163.html
537
538 CYRIX OPTIONS REMOVED
539 ---------------------
540
541 The following Cyrix related options have been removed: CPU_BTB_EN,
542 CPU_CYRIX_NO_LOCK, CPU_DIRECT_MAPPED_CACHE, CPU_DISABLE_5X86_LSSER,
543 CPU_FASTER_5X86_FPU, CPU_IORT, CPU_LOOP_EN, CPU_RSTK_EN, CPU_SUSP_HLT,
544 CYRIX_CACHE_WORKS, and CYRIX_CACHE_REALLY_WORKS
545
546 ISA SUPPORT REMOVED FROM RP(4)
547 ------------------------------
548
549 ISA support has been removed from the rp(4) driver. It is now PCI only.
550
551 +-----------------------------------------------------------------------+
552 +         UPGRADING DRAGONFLY FROM 3.2 TO LATER VERSIONS                +
553 +-----------------------------------------------------------------------+
554
555 COMPAT_SUNOS OPTION REMOVED
556 ---------------------------
557
558 The COMPAT_SUNOS option has been removed. It was meant to provide binary
559 compatibility with SunOS 4.x for the sparc32 port of 4.4BSD.
560
561 ISA SOUND CARD SUPPORT REMOVED
562 ------------------------------
563
564 The following modules have been removed (all for ISA sound cards):
565 snd_ad1816.ko, snd_ess.ko, snd_mss.ko, snd_sb8.ko, snd_sb16.ko, snd_sbc.ko
566
567 GCC 4.7
568 -------
569
570 DragonFly has switched base compilers.  GCC 4.7 is now the default
571 compiler and GCC 4.4 is the alternative compiler.  The "NO_GCC47" make
572 variable ceases to work now.
573
574 Users who wish to build only GCC 4.7 have to use NO_GCC44 in the
575 /etc/make.conf to prohibit GCC 4.4 from building.  However, using it is
576 highly discouraged.  There are a few packages in pkgsrc that do not build
577 with GCC 4.7 and the new "DPorts" system uses GCC 4.4 by default.  At
578 this time, it is recommended to keep both compilers on the base system.
579
580 SMP OPTION REMOVED
581 ------------------
582
583 The SMP kernel option has been made a no-op. All kernels now feature SMP
584 support. If you have 'options SMP' in your kernel config, you can as well
585 remove it.
586
587 DEVICE_POLLING OPTION REPLACED BY IFPOLL_ENABLE OPTION, KTR_POLLING REMOVED
588 ---------------------------------------------------------------------------
589
590 The DEVICE_POLLING kernel option has been made a no-op and it has been
591 replaced by IFPOLL_ENABLE.  If you have 'options DEVICE_POLLING' in your
592 kernel config, you need to change it to IFPOLL_ENABLE.
593
594 Also, the KTR_POLLING kernel option has been removed, so it must be
595 removed from kernel configs that have it.
596
597 BUSLOGIC, CYCLADES AND STALLION ISA SUPPORT REMOVED
598 ---------------------------------------------------
599
600 The bt(4) driver for Buslogic SCSI adapters has been made PCI only. ISA
601 cards will no longer be detected.
602
603 The same has been done for Stallion multiport serial controllers. stli(4)
604 has been completely removed (along with the stlload(8) and stlstty(8)
605 utilities) and stl(4) was changed to support only PCI cards. Similarly,
606 ISA support was removed from cy(4) too. All these drivers are i386 only.
607
608 COMPAT_OLDISA OPTION GONE
609 -------------------------
610
611 The i386 specific COMPAT_OLDISA kernel option has been removed, since
612 nothing needs it anymore.
613
614 +-----------------------------------------------------------------------+
615 +         UPGRADING DRAGONFLY FROM 3.0 TO LATER VERSIONS                +
616 +-----------------------------------------------------------------------+
617
618 APIC_IO OPTION REMOVED
619 ----------------------
620
621 The APIC_IO kernel option is no longer accepted after having been without
622 effect for a while. The hw.ioapic_enable tunable now serves its purpose.
623 If you have 'options APIC_IO' in your kernel config, you'll have to
624 remove it.
625
626 WATCHDOG_ENABLE & HW_WDOG OPTIONS REMOVED
627 -----------------------------------------
628
629 The wdog framework is now compiled into our kernels by default, so the
630 options are no longer needed.
631
632 DOSCMD(1) REMOVED
633 -----------------
634
635 doscmd(1) has been removed. It was i386 only. The doscmd(1) specific
636 NO_X make.conf option was removed too.
637
638 GCC 4.7
639 -------
640
641 GCC 4.7 has been brought in and replaces GCC 4.1 as DragonFly's non-
642 default compiler in base (default is still GCC 4.4).
643
644 Users who wish to build only GCC 4.4 have to replace NO_GCC41 with
645 NO_GCC47 in /etc/make.conf.
646
647 USB4BSD
648 -------
649
650 A new USB stack (from FreeBSD) has been brought in. The following
651 modules have been ported so far: usb, uhci, ohci, ehci, xhci, umass,
652 usfs, uether, if_axe, if_udav, ukbd, ums, uep, uhid, usb_quirk,
653 and uaudio.
654
655 It is not yet the default. To activate it, WANT_USB4BSD=yes has to
656 be put in make.conf and device "usb4bsd" (quotes needed) has to
657 replace device usb in the kernel config. After that, a full
658 build/install/upgrade cycle is needed.
659
660 Note that this is experimental and incomplete, but we are interested
661 in hearing about issues with it, of course.
662
663 ISA SUPPORT REMOVED FROM AIC-6260/6360 DRIVER
664 ---------------------------------------------
665
666 ISA adapter support was dropped from the aic(4) driver.
667
668 +-----------------------------------------------------------------------+
669 +         UPGRADING DRAGONFLY FROM 2.10 TO LATER VERSIONS               +
670 +-----------------------------------------------------------------------+
671
672 SEVERAL ISA DRIVERS REMOVED
673 ---------------------------
674
675 The following ISA only drivers have been removed along with a couple of
676 associated userland tools:
677
678 aha(4)
679 asc(4) & sasc(1)
680 ctx
681 dgb(4)
682 el(4)
683 gpib
684 gsc(4) & sgsc(1)
685 ie(4)
686 labpc(4)
687 le(4)
688 mse(4)
689 rc(4)
690 rdp(4)
691 spigot
692 tw(4) & xten(1) & xtend(8)
693 wl(4) & wlconfig(8)
694 wt(4)
695
696 Note that two of these drivers (aha(4) and ie(4)) are in our GENERIC
697 config and one (aha(4)) is in our X86_64_GENERIC kernel configuration
698 file.
699
700 If buildkernel complains about any of these drivers, just remove them
701 from your kernel configuration.
702
703 BINUTILS 2.20
704 -------------
705 Binutils 2.20 has been removed in favor of Binutils 2.22.  The accepted
706 values of BINUTILSVERS are now binutils221 and binutils222 (default).
707
708 BUILDWORLD/-KERNEL PARALLELIZATION WORK
709 ---------------------------------------
710 Due to changes in the way we build with more than one make job, you
711 will have to update install(1) and mkdir(1) prior to buildworld if you
712 want to build with 'make -j':
713
714 cd /usr/src/usr.bin/xinstall; make; make install; make clean
715 cd /usr/src/bin/mkdir; make; make install; make clean
716
717 DMA(8) UPGRADE
718 --------------
719 dma(8) has been upgraded to v0.7 which no longer supports the
720 /etc/dma/virtusertable. Some of its functionality has been replaced
721 with the MASQUERADE keyword and the EMAIL environment variable (see
722 the dma(8) manual page).
723
724 +-----------------------------------------------------------------------+
725 +         UPGRADING DRAGONFLY FROM 2.8 TO LATER VERSIONS                +
726 +-----------------------------------------------------------------------+
727
728 GCC 4.4 & BINUTILS 2.21
729 -----------------------
730
731 GCC 4.4 has been made DragonFly's default compiler and Binutils 2.21 has
732 been made DragonFly's default Binutils.
733
734 That means that any settings that set CCVER to 'gcc44' are not needed
735 anymore. Instead, CCVER can be set to 'gcc41' to go back to using
736 GCC 4.1.
737
738 It also means that 'binutils221' as a value for BINUTILSVER has no
739 effect anymore. 2.17 has been removed and 'binutils220' is available
740 as an option.
741
742 The NO_GCC44 option has been removed and will not affect the build
743 anymore. There is now a NO_GCC41 option that will prevent GCC 4.1 from
744 building in a similar fashion.
745
746 Note that you must do a full buildworld/buildkernel for upgrading.
747
748 pkg_radd settings
749 -----------------
750
751 The config file for pkg_radd has moved from /etc/settings.conf to 
752 /etc/pkg_radd.conf.  Save the contents of settings.conf before upgrading
753 if this is needed.  This warning only applies if /etc/settings.conf 
754 exists.  pkg_radd will continue to work with defaults.
755
756 +-----------------------------------------------------------------------+
757 +         20100927                                                      +
758 +         UPGRADING DRAGONFLY FROM 2.6 to 2.8 or HEAD                   +
759 +-----------------------------------------------------------------------+
760
761 OpenSSL
762 --------
763
764 OpenSSL has been upgraded, and SHLIB_MAJOR was bumped for libssh and libcrypto.
765 This shouldn't break any 3rd-party software, but you'll need to recompile your
766 3rd-party software if you want it to link against the new version of OpenSSL.
767
768 Loader
769 -------
770
771 A new loader (dloader) has been added which better handles booting from
772 multiple kernel/module versions.
773
774 To upgrade (Only for this upgrade, for post 2.8 upgrades see GENERAL below)
775
776         cd /usr/src
777         make buildworld
778         make installworld
779         make upgrade
780         make buildkernel KERNCONF=<KERNELNAME>
781         make installkernel KERNCONF=<KERNELNAME>
782
783 Note that you must installworld and run the 'upgrade' target before
784 installing the new kernel.
785
786 BIND
787 -----
788
789 BIND has been removed from the base system.  The ldns and drill tools have 
790 been added for basic functionality.  Use 'drill' where you would normally 
791 use nslookup or dig, or install BIND from pkgsrc.  It's available as 
792 net/bind95, net/bind96, or net/bind97 as of this writing.
793
794 This only affects older systems upgrading to 2.8.  New 2.8+ installs 
795 include BIND as a pkgsrc package.
796
797 +-----------------------------------------------------------------------+
798 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
799 +                               GENERAL                                 +
800 +-----------------------------------------------------------------------+
801
802 Instructions on how to obtain and maintain DragonFly source code using git
803 are in the development(7) manual page.
804
805 To upgrade a DragonFly system from sources you run the following sequence:
806
807         cd /usr/src
808         make buildworld
809         make buildkernel KERNCONF=<KERNELNAME>
810         make installkernel KERNCONF=<KERNELNAME>
811         make installworld
812
813 You will also want to run the 'upgrade' target to upgrade your /etc and the
814 rest of your system.  The upgrade target is aware of stale files created by
815 older DragonFly installations and should delete them automatically.
816
817         make upgrade
818
819 See the build(7) manual page for further information.
820
821 Once you've done a full build of the world and kernel you can do incremental
822 upgrades of either by using the 'quickworld' and 'quickkernel' targets
823 instead of 'buildworld' and 'buildkernel'.  If you have any problems with
824 the quick targets, try updating your repo first, and then a full buildworld
825 and buildkernel as shown above, before asking for help.
826
827 +-----------------------------------------------------------------------+
828 +         UPGRADING FROM DRAGONFLY <= 2.0 TO DRAGONFLY >= 2.1           +
829 +-----------------------------------------------------------------------+
830
831 In 2.1 kernel and modules has moved to boot directory.  For most cases
832 this is handled automatically by 'make upgrade'.  A few cases needs manual
833 intervention:
834
835  * When installing a kernel without first doing a make buildworld,
836    installworld and upgrade to the same DESTDIR as kernel:
837    make DESTDIR/boot directory and move kernel and modules into this boot
838    directory; also move kernel.old and modules.old.
839    Typical example is vkernel(7), use (no modules used):
840
841         cd /var/vkernel
842         mkdir boot
843         chflags noschg kernel
844         mv kernel kernel.old boot
845         chflags schg boot/kernel
846         
847  * When using a boot-only partition, /boot/loader.rc needs to be edited:
848    delete occurrences of '/boot/'.
849    These occurences can normally be deleted in any case, see loader(8).
850
851 +-----------------------------------------------------------------------+
852 +         UPGRADING FROM DRAGONFLY <= 1.8 TO DRAGONFLY >= 1.9           +
853 +-----------------------------------------------------------------------+
854
855 In 1.9 major changes to the disk management infrastructure have taken
856 place.  make upgrade may not catch all of your disk devices in /dev,
857 so after upgrading be sure to cd /dev; ./MAKEDEV <blah> where <blah>
858 are all of your disk devices.  HOWEVER, from late 2.3 on we run devfs
859 and MAKEDEV no longer exists.
860
861 The biggest changes in 1.9 are:
862
863 (1) That whole-slice devices such as da0s1 no longer share the same device
864     id as partition c devices such as da0s1c.
865
866 (2) The whole-disk device (e.g. da0) is full raw access to the disk,
867     with no snooping or reserved sectors.  Consequently you cannot run
868     disklabel on this device.  Instead you must run disklabel on a
869     whole-slice device.
870
871 (3) The 'compatibility' partitions now use slice 0 in the device name,
872     so instead of da0a you must specify da0s0a.  Also, as per (1) above,
873     accessing the disklabel for the compatibility partitions must be
874     done via slice 0 (da0s0).
875
876 (4) Many device drivers that used to fake up labels, such as CD, ACD, VN,
877     and CCD now run through the disk management layer and are assigned
878     real disk management devices.   VN and CCD in particular do not usually
879     use a MBR and disklabels must be accessed through the compatibility
880     slice 0.  Your /etc/ccd.conf file still specifies 'ccd0', though, you
881     don't name it 'ccd0s0' in the config file.
882
883 Generally speaking, you have to get used to running fdisk and disklabel on
884 the correctly specified device names.  A lot of the wiggle, such as running
885 disklabel on a partition, has been removed.
886
887 +-----------------------------------------------------------------------+
888 +         UPGRADING FROM OLDER VERSIONS OF DRAGONFLY OR FREEBSD         +
889 +-----------------------------------------------------------------------+
890
891 > Kerberos IV
892 -------------
893
894 Kerberos IV (eBones) was removed from the tree, please consider moving to
895 Kerberos 5 (Heimdal).
896
897 > Package Management System
898 ---------------------------
899
900 Starting with the 1.4 release, DragonFly uses NetBSD's pkgsrc package
901 management system.  The necessary tools to build and maintain packages
902 are provided in /usr/pkg/bin and /usr/pkg/sbin.  Make sure that these
903 directories are in your PATH variable.
904
905 In order to obtain a reasonably current snapshot of the pkgsrc tree, use
906 the tarball from NetBSD:
907
908         fetch -o /tmp/pkgsrc.tar.gz ftp://ftp.NetBSD.org/pub/NetBSD/packages/pkgsrc.tar.gz
909         cd /usr; tar -xzf /tmp/pkgsrc.tar.gz; chown -R root:wheel pkgsrc
910
911 This tree can then be kept up to date with cvs update:
912
913         cd /usr/pkgsrc; cvs up
914
915 NOTE! If you upgraded from a pre-1.4 system to 1.4 or later, you need to
916 build and install the pkgsrc bootstrap manually:
917
918         cd /usr/pkgsrc/bootstrap
919         ./bootstrap --pkgdbdir /var/db/pkg --prefix /usr/pkg
920
921 +-----------------------------------------------------------------------+
922 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
923 +         UPDATING FROM PRE-1.2 SYSTEMS OR FreeBSD 4.x TO               +
924 +         DRAGONFLY 1.3+ (EITHER PREVIEW or HEAD)                       +
925 +-----------------------------------------------------------------------+
926
927 The compatibility shims for the build environment have been removed, you
928 have to update to DragonFly 1.2 release branch first.
929
930 The default PAM configuration has moved from /etc/pam.conf to /etc/pam.d/.
931 The existing configuration can be converted using /etc/pam.d/convert.sh.
932 Entries in /etc/pam.d/ override entries in /etc/pam.conf. In addition
933 the pam_skey.so module was retired, you have to remove it manually from
934 your configuration, when you convert it.
935
936 > Required user and group IDs when upgrading from either FreeBSD or DragonFly
937 ---------------------
938
939 The following users may be missing from your password file.  Use vipw and
940 add any that are missing:
941
942 smmsp:*:25:25::0:0:Sendmail Submission User:/var/spool/clientmqueue:/sbin/nologin
943 _pflogd:*:64:64::0:0:pflogd privsep user:/var/empty:/sbin/nologin
944
945 The following groups may be missing from your group file.  Use vi /etc/group
946 and add any that are missing:
947
948 smmsp:*:25:
949 authpf:*:63:
950 _pflogd:*:64:
951
952
953 > Upgrading to DragonFly from FreeBSD
954 ---------------------
955
956 You can build the DragonFly world and DragonFly kernels on a FreeBSD-4.x or
957 FreeBSD-5.x machine and then install DragonFly over FreeBSD, replacing
958 FreeBSD.  Note that the DragonFly buildworld target does not try to reuse
959 make depend information, it starts from scratch, so no pre-cleaning of the
960 object hierarchy is necessary.
961
962         # get the CVS repository (it is placed in /home/dcvs, 500MB).
963         # Please use the -h option and a mirror site to pull the 
964         # initial repository, but feel free to use the main repository
965         # machine to pull updates.
966         cvsup /usr/share/examples/cvsup/DragonFly-cvs-supfile
967         # install the source from the CVS hierarchy (remove preexisting
968         # FreeBSD src first) (500MB)
969         cd /usr
970         rm -rf src
971         cvs -R -d /home/dcvs checkout -P src
972
973         # build it (500MB used in /usr/obj)
974         #
975         cd /usr/src
976         make buildworld
977         make buildkernel KERNCONF=<KERNELNAME>
978
979 Once you have built DragonFly you have to install it over FreeBSD.  Since
980 DragonFly does not track changes made by FreeBSD to its include file 
981 hierarchy and include file pollution can cause all sorts of unexpected
982 compilation issues to come up, it is best to wipe your include hierarchy
983 prior to installing DragonFly.  Note that you should not wipe any installed
984 FreeBSD header files or binaries until after you have successfully completed
985 the build steps above.
986
987         rm -rf /usr/include
988         mkdir /usr/include
989         make installkernel KERNCONF=<KERNELNAME>
990         make installworld
991
992 Then you need to upgrade your system.  DragonFly's 'make upgrade' target 
993 will unconditionally upgrade the /etc files that sysops do not usually
994 mess around with, such as the files in /etc/rc.d.  It will also remove any
995 obsolete files such as utilities and manpages that have been removed from
996 the system since the version you're coming from.  If you are unsure we 
997 recommend that you make a backup of at least your /etc before applying
998 this step.  Note that DragonFly's RC system is basically RCNG from
999 FreeBSD-5, but there are some differences in the contents of the RC files.
1000
1001         make upgrade
1002
1003 NOTE! Never do a 'make upgrade' before 'make installworld' has been run.
1004 Doing so might leave your system in an unusable state.
1005
1006 Finally we recommend that you do an 'ls -lta BLAH' for /bin, /sbin, /usr/bin,
1007 /usr/bin, and /usr/lib, and remove any stale files that you find.  Please
1008 report these files to the DragonFly developers so that they can be added to
1009 the 'upgrade' target.
1010